Compare commits

...

41 Commits

Author SHA1 Message Date
Tonye Jack
528984a4f8 Merge pull request #654 from tj-actions/chore/add-back-ability-to-fetch-branch-history 2022-09-28 20:49:21 -06:00
Tonye Jack
1b438493cf chore: add back ability to fetch branch history 2022-09-28 20:42:32 -06:00
renovate[bot]
3b54ee8a34 chore(deps): update peter-evans/create-pull-request action to v4.1.3 2022-09-28 00:42:48 -06:00
Tonye Jack
ffddd5941d Merge pull request #652 from tj-actions/upgrade-to-v31.0.1 2022-09-25 10:53:48 -06:00
jackton1
6313c343d4 Upgraded from v31.0.0 -> v31.0.1 2022-09-25 16:47:06 +00:00
Tonye Jack
75af1a47c4 Merge pull request #651 from tj-actions/fix/bug-with-forced-pushed-commits 2022-09-25 09:46:20 -06:00
Tonye Jack
b50afacfed updated get-base-sha.sh 2022-09-25 09:31:57 -06:00
Tonye Jack
7de6088904 Updated check 2022-09-25 09:23:05 -06:00
Tonye Jack
8281b8ad57 fix: bug with force pushed commits 2022-09-25 09:19:22 -06:00
Tonye Jack
d82ceda8a1 Merge pull request #650 from tj-actions/upgrade-to-v31.0.0 2022-09-25 08:43:17 -06:00
jackton1
bff472661c Upgraded from v30 -> v31.0.0 2022-09-25 08:01:32 +00:00
repo-ranger[bot]
5184a750a6 Merge pull request #649 from tj-actions/chore/update-test
chore: updated test
2022-09-25 06:12:03 +00:00
Tonye Jack
f60f9d4d6b chore: updated test 2022-09-25 00:00:23 -06:00
Tonye Jack
9d736a1803 Merge pull request #648 from tj-actions/chore/update-docs 2022-09-24 22:29:29 -06:00
Tonye Jack
d77ab55ce1 chore: update docs 2022-09-24 21:20:05 -06:00
Tonye Jack
13c0052761 Merge pull request #647 from tj-actions/chore/remove-logging-the-github-context 2022-09-24 21:03:00 -06:00
Tonye Jack
bc7fa5e550 Updated determining the remote sha 2022-09-24 20:52:05 -06:00
Tonye Jack
3d7cff9835 chore: remove logging the github context 2022-09-24 20:28:43 -06:00
Tonye Jack
cc6619bd58 Merge pull request #646 from tj-actions/chore/improve-debug-message 2022-09-24 20:27:17 -06:00
Tonye Jack
4cd2d9f19e Fixed test 2022-09-24 20:21:08 -06:00
Tonye Jack
69d9410ad3 chore: improve debug message. 2022-09-24 19:59:18 -06:00
Tonye Jack
f038bbbed9 Merge pull request #644 from tj-actions/feat/make-since-last-remote-the-default 2022-09-24 19:45:29 -06:00
Tonye Jack
05f9744e41 remove unused code 2022-09-24 19:33:47 -06:00
Tonye Jack
ef1134dca7 update to handle the default event.before 2022-09-24 19:33:05 -06:00
Tonye Jack
de772eb038 added empty line 2022-09-24 19:11:18 -06:00
Tonye Jack
5485a02af8 Updated to use the last remote commit by default. 2022-09-24 19:08:58 -06:00
Tonye Jack
2c4c729f2a revert removing since-last-remote-commit input 2022-09-24 18:59:22 -06:00
Tonye Jack
b6b72a44c8 Updated to use INPUT_HAS_CUSTOM_PATTERNS. 2022-09-24 18:35:01 -06:00
Tonye Jack
0ec94592d4 Renamed entrypoint.sh -> get-changed-paths.sh 2022-09-24 18:30:52 -06:00
Tonye Jack
068970bff8 reorder inputs 2022-09-24 18:12:07 -06:00
Tonye Jack
26361016d9 Fixed test. 2022-09-24 17:49:47 -06:00
Tonye Jack
1f907ee3bb feat: make since_last_remote the default for push events 2022-09-24 13:07:33 -06:00
Tonye Jack
fc8e4597a7 Update README.md 2022-09-24 12:36:07 -06:00
Tonye Jack
08dfcc4c04 Update README.md 2022-09-24 12:30:01 -06:00
Tonye Jack
8cbcb5bd41 Merge pull request #643 from tj-actions/chore/update-test
chore: update test
2022-09-24 09:17:49 -06:00
Tonye Jack
865fd6e79a chore: update test 2022-09-24 00:48:58 -06:00
Tonye Jack
769bb7f140 Merge pull request #642 from tj-actions/chore/update-broken-link
chore: update broken link
2022-09-24 00:34:34 -06:00
Tonye Jack
ca2731c4b9 chore: update broken link 2022-09-24 00:34:19 -06:00
Tonye Jack
2bbb2f249d Update README.md 2022-09-24 00:00:08 -06:00
Tonye Jack
bb03b8754a Merge pull request #641 from tj-actions/upgrade-to-v30.0.0
Upgraded to v30.0.0
2022-09-23 23:57:41 -06:00
jackton1
3e3de07034 Upgraded from v29 -> v30.0.0 2022-09-24 05:53:14 +00:00
11 changed files with 220 additions and 153 deletions

View File

@@ -19,7 +19,7 @@ jobs:
git submodule update --remote --recursive
- name: Create Pull Request
uses: peter-evans/create-pull-request@v4.1.2
uses: peter-evans/create-pull-request@v4.1.3
with:
title: "Updated submodule"
branch: "chore/update-submodule"

View File

@@ -26,7 +26,7 @@ jobs:
with:
output: 'HISTORY.md'
- name: Create Pull Request
uses: peter-evans/create-pull-request@v4.1.2
uses: peter-evans/create-pull-request@v4.1.3
with:
base: "main"
title: "Upgraded to ${{ steps.sync-release-version.outputs.new_version }}"

View File

@@ -28,46 +28,6 @@ jobs:
- name: shellcheck
uses: reviewdog/action-shellcheck@v1.15
test-pull-requests-from-forks:
name: Test changed-files diff on pull_requests from forks
runs-on: ${{ matrix.platform }}
strategy:
fail-fast: false
max-parallel: 4
matrix:
platform: [ubuntu-latest, ubuntu-22.04, windows-latest, macos-latest, macos-11, ubuntu-18.04, windows-2022]
steps:
- name: Checkout
uses: actions/checkout@v3
with:
submodules: true
fetch-depth: 0
- name: Get changed files use_fork_point
id: changed-files-fork-point
uses: ./
with:
use_fork_point: "true"
- name: Show output
run: |
echo '${{ toJSON(steps.changed-files-fork-point.outputs) }}'
shell:
bash
- name: Get changed files
id: changed-files
uses: ./
with:
base_sha: ${{ github.event.pull_request.base.sha }}
- name: Show output
run: |
echo '${{ toJSON(steps.changed-files.outputs) }}'
shell:
bash
test-multiple-repositories:
name: Test with multiple repositories
runs-on: ${{ matrix.platform }}
@@ -176,14 +136,7 @@ jobs:
- name: Run changed-files with a single commit history
id: changed-files
continue-on-error: true
uses: ./
- name: Exit with 1 if no error is raised
if: github.event_name == 'pull_request' && steps.changed-files.outcome != 'failure'
run: |
echo "Expected: (failure) got ${{ steps.changed-files.outcome }}"
exit 1
- name: Show output
run: |
@@ -310,8 +263,6 @@ jobs:
with:
submodules: true
fetch-depth: 0
- name: Show github context
run: echo '${{ toJSON(github) }}'
- name: Run changed-files with defaults
id: changed-files
uses: ./
@@ -562,10 +513,10 @@ jobs:
uses: ./
with:
files: |
entrypoint.sh
get-changed-paths.sh
*.sh
- name: Verify all_changed_files files has no duplicates
if: contains(steps.changed-files-specific-duplicate-output.outputs.all_changed_files, 'entrypoint.sh')
if: contains(steps.changed-files-specific-duplicate-output.outputs.all_changed_files, 'get-changed-paths.sh')
run: |
ALL_CHANGED_FILES=(${{ steps.changed-files-specific-duplicate-output.outputs.all_changed_files }})
UNIQUE_ALL_CHANGED_FILES=$(echo "$ALL_CHANGED_FILES" | tr ' ' '\n' | sort -u | xargs)
@@ -577,7 +528,7 @@ jobs:
shell:
bash
- name: Verify all_changed_and_modified_files files has no duplicates
if: contains(steps.changed-files-specific-duplicate-output.outputs.all_changed_and_modified_files, 'entrypoint.sh')
if: contains(steps.changed-files-specific-duplicate-output.outputs.all_changed_and_modified_files, 'get-changed-paths.sh')
run: |
ALL_CHANGED_AND_MODIFIED_FILES=(${{ steps.changed-files-specific-duplicate-output.outputs.all_changed_and_modified_files }})
UNIQUE_ALL_CHANGED_AND_MODIFIED_FILES=$(echo "$ALL_CHANGED_AND_MODIFIED_FILES" | tr ' ' '\n' | sort -u | xargs)
@@ -589,7 +540,7 @@ jobs:
shell:
bash
- name: Verify all_modified_files files has no duplicates
if: contains(steps.changed-files-specific-duplicate-output.outputs.all_modified_files, 'entrypoint.sh')
if: contains(steps.changed-files-specific-duplicate-output.outputs.all_modified_files, 'get-changed-paths.sh')
run: |
ALL_MODIFIED_FILES=(${{ steps.changed-files-specific-duplicate-output.outputs.all_modified_files }})
UNIQUE_ALL_MODIFIED_FILES=$(echo "$ALL_MODIFIED_FILES" | tr ' ' '\n' | sort -u | xargs)
@@ -859,19 +810,19 @@ jobs:
if: github.event_name == 'pull_request'
- uses: nrwl/last-successful-commit-action@v1
id: last_successful_commit
if: github.event_name == 'pull_request'
if: github.event_name == 'pull_request' && github.event.action != 'closed'
with:
branch: ${{ steps.branch-name.outputs.base_ref_branch }}
workflow_id: 'test.yml'
github_token: ${{ secrets.GITHUB_TOKEN }}
- name: Run changed-files with a custom base sha
if: github.event_name == 'pull_request'
if: github.event_name == 'pull_request' && github.event.action != 'closed'
id: changed-files-custom-base-sha
uses: ./
with:
base_sha: ${{ steps.last_successful_commit.outputs.commit_hash }}
- name: Show output
if: github.event_name == 'pull_request'
if: github.event_name == 'pull_request' && github.event.action != 'closed'
run: |
echo '${{ toJSON(steps.changed-files-custom-base-sha.outputs) }}'
shell:

View File

@@ -31,7 +31,7 @@ jobs:
- name: Create Pull Request
if: failure()
uses: peter-evans/create-pull-request@v4.1.2
uses: peter-evans/create-pull-request@v4.1.3
with:
base: "main"
title: "Updated README.md"

View File

@@ -1,5 +1,59 @@
# Changelog
## [v31.0.1](https://github.com/tj-actions/changed-files/tree/v31.0.1) (2022-09-25)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v31...v31.0.1)
## [v31](https://github.com/tj-actions/changed-files/tree/v31) (2022-09-25)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v31.0.0...v31)
**Merged pull requests:**
- fix: bug with force pushed commits [\#651](https://github.com/tj-actions/changed-files/pull/651) ([jackton1](https://github.com/jackton1))
- Upgraded to v31.0.0 [\#650](https://github.com/tj-actions/changed-files/pull/650) ([jackton1](https://github.com/jackton1))
## [v31.0.0](https://github.com/tj-actions/changed-files/tree/v31.0.0) (2022-09-25)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v30...v31.0.0)
**Merged pull requests:**
- chore: updated test [\#649](https://github.com/tj-actions/changed-files/pull/649) ([jackton1](https://github.com/jackton1))
- chore: update docs [\#648](https://github.com/tj-actions/changed-files/pull/648) ([jackton1](https://github.com/jackton1))
- chore: remove logging the github context [\#647](https://github.com/tj-actions/changed-files/pull/647) ([jackton1](https://github.com/jackton1))
- chore: improve debug message. [\#646](https://github.com/tj-actions/changed-files/pull/646) ([jackton1](https://github.com/jackton1))
- feat: use the last remote commit sha by default for push events [\#644](https://github.com/tj-actions/changed-files/pull/644) ([jackton1](https://github.com/jackton1))
- chore: update test [\#643](https://github.com/tj-actions/changed-files/pull/643) ([jackton1](https://github.com/jackton1))
- chore: update broken link [\#642](https://github.com/tj-actions/changed-files/pull/642) ([jackton1](https://github.com/jackton1))
- Upgraded to v30.0.0 [\#641](https://github.com/tj-actions/changed-files/pull/641) ([jackton1](https://github.com/jackton1))
## [v30](https://github.com/tj-actions/changed-files/tree/v30) (2022-09-24)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v30.0.0...v30)
## [v30.0.0](https://github.com/tj-actions/changed-files/tree/v30.0.0) (2022-09-24)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v29.0.9...v30.0.0)
**Fixed bugs:**
- \[BUG\] Can't get all changed files after pushing new commit [\#639](https://github.com/tj-actions/changed-files/issues/639)
- \[BUG\] Add support for pull request close event with merge set to true [\#635](https://github.com/tj-actions/changed-files/issues/635)
**Closed issues:**
- Dependency Dashboard [\#27](https://github.com/tj-actions/changed-files/issues/27)
**Merged pull requests:**
- feat: add support for closed pull requests with merge true [\#640](https://github.com/tj-actions/changed-files/pull/640) ([jackton1](https://github.com/jackton1))
- chore: log the github context in the test [\#638](https://github.com/tj-actions/changed-files/pull/638) ([jackton1](https://github.com/jackton1))
- chore: update test to run workflow on pull request close event [\#637](https://github.com/tj-actions/changed-files/pull/637) ([jackton1](https://github.com/jackton1))
- chore\(deps\): update peter-evans/create-pull-request action to v4.1.2 [\#636](https://github.com/tj-actions/changed-files/pull/636) ([renovate[bot]](https://github.com/apps/renovate))
- chore\(deps\): update codacy/codacy-analysis-cli-action action to v4.2.0 [\#634](https://github.com/tj-actions/changed-files/pull/634) ([renovate[bot]](https://github.com/apps/renovate))
- Upgraded to v29.0.9 [\#633](https://github.com/tj-actions/changed-files/pull/633) ([jackton1](https://github.com/jackton1))
## [v29.0.9](https://github.com/tj-actions/changed-files/tree/v29.0.9) (2022-09-20)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v29...v29.0.9)
@@ -24,10 +78,6 @@
- \[Feature\] Improve docs related to "files" [\#629](https://github.com/tj-actions/changed-files/issues/629)
**Closed issues:**
- Dependency Dashboard [\#27](https://github.com/tj-actions/changed-files/issues/27)
**Merged pull requests:**
- chore\(deps\): update tj-actions/sync-release-version action to v13 [\#631](https://github.com/tj-actions/changed-files/pull/631) ([renovate[bot]](https://github.com/apps/renovate))
@@ -869,7 +919,7 @@
## [v13](https://github.com/tj-actions/changed-files/tree/v13) (2022-02-17)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v2.0.1...v13)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v12.2...v13)
**Implemented enhancements:**
@@ -888,13 +938,13 @@
- \[BUG\] wrong result of any\_change output [\#314](https://github.com/tj-actions/changed-files/issues/314)
- \[BUG\] Investigate possible bug using since\_last\_remote\_commit when force pushing changes. [\#303](https://github.com/tj-actions/changed-files/issues/303)
## [v2.0.1](https://github.com/tj-actions/changed-files/tree/v2.0.1) (2021-12-30)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v12.2...v2.0.1)
## [v12.2](https://github.com/tj-actions/changed-files/tree/v12.2) (2021-12-30)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v12.1...v12.2)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v2.0.1...v12.2)
## [v2.0.1](https://github.com/tj-actions/changed-files/tree/v2.0.1) (2021-12-30)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v12.1...v2.0.1)
**Merged pull requests:**
@@ -1044,7 +1094,7 @@
## [v1.2.1](https://github.com/tj-actions/changed-files/tree/v1.2.1) (2021-11-08)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v1.2.0...v1.2.1)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v11.5...v1.2.1)
**Implemented enhancements:**
@@ -1058,13 +1108,13 @@
- Update actions/checkout action to v2.4.0 [\#243](https://github.com/tj-actions/changed-files/pull/243) ([renovate[bot]](https://github.com/apps/renovate))
- Upgraded to v11.5 [\#241](https://github.com/tj-actions/changed-files/pull/241) ([jackton1](https://github.com/jackton1))
## [v1.2.0](https://github.com/tj-actions/changed-files/tree/v1.2.0) (2021-10-30)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v11.5...v1.2.0)
## [v11.5](https://github.com/tj-actions/changed-files/tree/v11.5) (2021-10-30)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v11.4...v11.5)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v1.2.0...v11.5)
## [v1.2.0](https://github.com/tj-actions/changed-files/tree/v1.2.0) (2021-10-30)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v11.4...v1.2.0)
**Merged pull requests:**
@@ -1456,7 +1506,7 @@
## [v7](https://github.com/tj-actions/changed-files/tree/v7) (2021-06-09)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v6...v7)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v6.3...v7)
**Closed issues:**
@@ -1472,13 +1522,13 @@
- Update tj-actions/sync-release-version action to v8.7 [\#86](https://github.com/tj-actions/changed-files/pull/86) ([renovate[bot]](https://github.com/apps/renovate))
- Upgraded to v6.3 [\#85](https://github.com/tj-actions/changed-files/pull/85) ([jackton1](https://github.com/jackton1))
## [v6](https://github.com/tj-actions/changed-files/tree/v6) (2021-05-26)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v6.3...v6)
## [v6.3](https://github.com/tj-actions/changed-files/tree/v6.3) (2021-05-26)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v6.2...v6.3)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v6...v6.3)
## [v6](https://github.com/tj-actions/changed-files/tree/v6) (2021-05-26)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v6.2...v6)
**Merged pull requests:**

View File

@@ -19,7 +19,6 @@ Retrieve all changed files and directories relative to the target branch (`pull_
* Fast execution (0-2 seconds on average).
* Easy to debug.
* Boolean output indicating that certain files have been changed.
* Scales to large repositories.
* Git submodules support.
* No extra API calls.
@@ -32,11 +31,10 @@ Retrieve all changed files and directories relative to the target branch (`pull_
* [self-hosted runners](https://docs.github.com/en/actions/hosting-your-own-runners/about-self-hosted-runners) support.
* List all files and directories that have changed:
* Between the current pull request branch and the last commit on the target branch.
* Between the current pull request branch and the fork point on the target branch.
* Between the last commit and the current pushed change.
* Between the last remote branch commit and the current HEAD.
* Restrict change detection to a subset of files and directories:
* Report on files that have at least one change.
* Boolean output indicating that certain files have been changed.
* Using [Glob pattern](https://docs.github.com/en/actions/learn-github-actions/workflow-syntax-for-github-actions#filter-pattern-cheat-sheet) matching.
## Usage
@@ -71,7 +69,7 @@ jobs:
# Example 1
- name: Get changed files
id: changed-files
uses: tj-actions/changed-files@v29
uses: tj-actions/changed-files@v31
- name: List all changed files
run: |
@@ -82,7 +80,7 @@ jobs:
# Example 2
- name: Get changed files in the docs folder
id: changed-files-specific
uses: tj-actions/changed-files@v29
uses: tj-actions/changed-files@v31
with:
files: |
docs/**
@@ -178,11 +176,11 @@ Support this project with a :star:
- name: Get changed files using defaults
id: changed-files
uses: tj-actions/changed-files@v29
uses: tj-actions/changed-files@v31
- name: Get changed files using a comma separator
id: changed-files-comma
uses: tj-actions/changed-files@v29
uses: tj-actions/changed-files@v31
with:
separator: ","
@@ -204,7 +202,7 @@ Support this project with a :star:
- name: Get specific changed files
id: changed-files-specific
uses: tj-actions/changed-files@v29
uses: tj-actions/changed-files@v31
with:
files: |
my-file.txt
@@ -245,14 +243,14 @@ Support this project with a :star:
- name: Use a source file or list of file(s) to populate to files input.
id: changed-files-specific-source-file
uses: tj-actions/changed-files@v29
uses: tj-actions/changed-files@v31
with:
files_from_source_file: |
test/changed-files-list.txt
- name: Use a source file or list of file(s) to populate to files input and optionally specify more files.
id: changed-files-specific-source-file-and-specify-files
uses: tj-actions/changed-files@v29
uses: tj-actions/changed-files@v31
with:
files_from_source_file: |
test/changed-files-list.txt
@@ -261,13 +259,13 @@ Support this project with a :star:
- name: Use a different commit SHA
id: changed-files-custom-sha
uses: tj-actions/changed-files@v29
uses: tj-actions/changed-files@v31
with:
sha: ${{ github.event.pull_request.head.sha }}
- name: Use a different base SHA
id: changed-files-custom-base-sha
uses: tj-actions/changed-files@v29
uses: tj-actions/changed-files@v31
with:
base_sha: ${{ github.event.pull_request.base.sha }}
@@ -279,7 +277,7 @@ Support this project with a :star:
- name: Run changed-files with defaults on the dir1
id: changed-files-for-dir1
uses: tj-actions/changed-files@v29
uses: tj-actions/changed-files@v31
with:
path: dir1
@@ -291,13 +289,13 @@ Support this project with a :star:
- name: Run changed-files using the last commit on the remote branch
id: changed-files-since-last-remote-commit
uses: tj-actions/changed-files@v29
uses: tj-actions/changed-files@v31
with:
since_last_remote_commit: "true"
- name: Run changed-files with quotepath disabled
id: changed-files-quotepath
uses: tj-actions/changed-files@v29.
uses: tj-actions/changed-files@v31
with:
quotepath: "false"
@@ -308,7 +306,7 @@ Support this project with a :star:
# Push event based workflows
- name: Get branch name
id: branch-name
uses: tj-actions/branch-names@v5
uses: tj-actions/branch-names@v6
- uses: nrwl/last-successful-commit-action@v1
id: last_successful_commit_push
@@ -319,7 +317,7 @@ Support this project with a :star:
- name: Run changed-files with the commit of the last successful test workflow run
id: changed-files-base-sha-push
uses: tj-actions/changed-files@v29.0.7
uses: tj-actions/changed-files@v31
with:
base_sha: ${{ steps.last_successful_commit_push.outputs.commit_hash }}
@@ -340,32 +338,32 @@ Support this project with a :star:
- name: Run changed-files with the commit of the last successful test workflow run on main
if: github.event_name == 'pull_request'
id: changed-files-base-sha-pull-request
uses: tj-actions/changed-files@v29
uses: tj-actions/changed-files@v31
with:
base_sha: ${{ steps.last_successful_commit_pull_request.outputs.commit_hash }}
- name: Run changed-files with dir_names
id: changed-files-dir-names
uses: tj-actions/changed-files@v29
uses: tj-actions/changed-files@v31
with:
dir_names: "true"
# All outputs are JSON formatted arrays and can be used in other actions and matrix compatible jobs.
- name: Run changed-files with json output
id: changed-files-json
uses: tj-actions/changed-files@v29
uses: tj-actions/changed-files@v31
wi
json: "true"
- name: Run changed-files since 2022-08-19
id: changed-files-since
uses: tj-actions/changed-files@v29
uses: tj-actions/changed-files@v31
with:
since: "2022-08-19"
- name: Run changed-files until 2022-08-20
id: changed-files-until
uses: tj-actions/changed-files@v29
uses: tj-actions/changed-files@v31
with:
until: "2022-08-20"
```

View File

@@ -151,40 +151,33 @@ runs:
using: "composite"
steps:
- run: |
# "Set base sha..."
if [[ -n "${{ inputs.since }}" ]]; then
BASE_SHA=$(git log --format="%H" --date=local --since="${{ inputs.since }}" --reverse | head -n 1)
if [[ -z "$BASE_SHA" ]]; then
echo "::warning::The BASE_SHA for date '${{ inputs.since }}' couldn't be determined."
fi
echo "::set-output name=base_sha::$BASE_SHA"
elif [[ -n "${{ inputs.base_sha }}" ]]; then
echo "::set-output name=base_sha::${{ inputs.base_sha }}"
elif [[ "${{ inputs.since_last_remote_commit }}" == "true" ]]; then
LAST_REMOTE_COMMIT="${{ github.event.before }}"
if [[ -z "$LAST_REMOTE_COMMIT" || "$LAST_REMOTE_COMMIT" == "0000000000000000000000000000000000000000" ]]; then
LAST_REMOTE_COMMIT=$(git rev-parse $(git branch -r --sort=-committerdate | head -1))
fi
if [[ "${{ inputs.sha }}" == "$LAST_REMOTE_COMMIT" ]]; then
LAST_REMOTE_COMMIT=$(git rev-parse "${{ inputs.sha }}^1")
fi
echo "::set-output name=base_sha::$LAST_REMOTE_COMMIT"
fi
# "Calculate the base sha..."
bash $GITHUB_ACTION_PATH/get-base-sha.sh
id: base-sha
shell: bash
env:
GITHUB_WORKSPACE: ${{ github.workspace }}
GITHUB_EVENT_BEFORE: ${{ github.event.before }}
GITHUB_EVENT_FORCED : ${{ github.event.forced }}
# INPUT_<VARIABLE_NAME> is not available in Composite run steps
# https://docs.github.com/en/actions/creating-actions/metadata-syntax-for-github-actions#example-specifying-inputs
INPUT_SINCE: ${{ inputs.since }}
INPUT_BASE_SHA: ${{ inputs.base_sha }}
INPUT_SHA: ${{ inputs.sha }}
INPUT_PATH: ${{ inputs.path }}
INPUT_SINCE_LAST_REMOTE_COMMIT: ${{ inputs.since_last_remote_commit }}
- run: |
# "Set the sha..."
if [[ -n "${{ inputs.until }}" ]]; then
SHA=$(git log -1 --format="%H" --date=local --until="${{ inputs.until }}")
if [[ -z "$SHA" ]]; then
echo "::warning::The SHA for date '${{ inputs.until }}' couldn't be determined, falling back to the current sha."
fi
echo "::set-output name=sha::$SHA"
else
echo "::set-output name=sha::${{ inputs.sha }}"
fi
# "Calculate the sha..."
bash $GITHUB_ACTION_PATH/get-sha.sh
id: sha
shell: bash
env:
GITHUB_WORKSPACE: ${{ github.workspace }}
# INPUT_<VARIABLE_NAME> is not available in Composite run steps
# https://docs.github.com/en/actions/creating-actions/metadata-syntax-for-github-actions#example-specifying-inputs
INPUT_UNTIL: ${{ inputs.until }}
INPUT_SHA: ${{ inputs.sha }}
INPUT_PATH: ${{ inputs.path }}
- run: |
# "Calculating the previous and current SHA..."
bash $GITHUB_ACTION_PATH/diff-sha.sh
@@ -195,11 +188,12 @@ runs:
GITHUB_REPOSITORY: ${{ github.repository }}
GITHUB_BASE_REF: ${{ github.base_ref }}
GITHUB_HEAD_REF: ${{ github.head_ref }}
GITHUB_ACTION_PATH: ${{ github.action_path }}
GITHUB_WORKSPACE: ${{ github.workspace }}
GITHUB_PULL_REQUEST_BASE_SHA: ${{ github.event.pull_request.base.sha }}
GITHUB_EVENT_BEFORE: ${{ github.event.before }}
GITHUB_EVENT_FORCED : ${{ github.event.forced }}
# INPUT_<VARIABLE_NAME> is not available in Composite run steps
# https://github.community/t/input-variable-name-is-not-available-in-composite-run-steps/127611
# https://docs.github.com/en/actions/creating-actions/metadata-syntax-for-github-actions#example-specifying-inputs
INPUT_SHA: ${{ steps.sha.outputs.sha }}
INPUT_BASE_SHA: ${{ steps.base-sha.outputs.base_sha }}
INPUT_PATH: ${{ inputs.path }}
@@ -209,22 +203,21 @@ runs:
with:
files: ${{ inputs.files }}
files-separator: ${{ inputs.files_separator }}
escape-paths: true
excluded-files: ${{ inputs.files_ignore }}
excluded-files-separator: ${{ inputs.files_ignore_separator }}
files-from-source-file: ${{ inputs.files_from_source_file }}
excluded-files-from-source-file: ${{ inputs.files_ignore_from_source_file}}
escape-paths: true
working-directory: ${{ inputs.path }}
base-sha: ${{ steps.changed-files-diff-sha.outputs.previous_sha }}
sha: ${{ steps.changed-files-diff-sha.outputs.current_sha }}
include-deleted-files: true
separator: "|"
- run: |
bash $GITHUB_ACTION_PATH/entrypoint.sh
bash $GITHUB_ACTION_PATH/get-changed-paths.sh
id: changed-files
shell: bash
env:
GITHUB_ACTION_PATH: ${{ github.action_path }}
GITHUB_WORKSPACE: ${{ github.workspace }}
# INPUT_<VARIABLE_NAME> is not available in Composite run steps
# https://docs.github.com/en/actions/creating-actions/metadata-syntax-for-github-actions#example-specifying-inputs
@@ -242,6 +235,7 @@ runs:
INPUT_DIFF_RELATIVE: ${{ inputs.diff_relative }}
INPUT_DIR_NAMES: ${{ inputs.dir_names }}
INPUT_JSON: ${{ inputs.json }}
INPUT_HAS_CUSTOM_PATTERNS: ${{ steps.glob.outputs.has-custom-patterns }}
branding:
icon: file-text

View File

@@ -57,30 +57,39 @@ else
fi
if [[ -z $GITHUB_BASE_REF ]]; then
TARGET_BRANCH=${GITHUB_REF/refs\/heads\//}
CURRENT_BRANCH=$TARGET_BRANCH
echo "::debug::GITHUB_BASE_REF unset using $TARGET_BRANCH..."
echo "Running on a push event..."
TARGET_BRANCH=${GITHUB_REF/refs\/heads\//} && exit_status=$? || exit_status=$?
CURRENT_BRANCH=$TARGET_BRANCH && exit_status=$? || exit_status=$?
if [[ -z $INPUT_BASE_SHA ]]; then
git fetch --no-tags -u --progress origin --depth=2 "${TARGET_BRANCH}":"${TARGET_BRANCH}" && exit_status=$? || exit_status=$?
PREVIOUS_SHA=""
if [[ $(git rev-list --count "HEAD") -gt 1 ]]; then
PREVIOUS_SHA=$(git rev-parse "@~1" 2>&1) && exit_status=$? || exit_status=$?
echo "::debug::Previous SHA: $PREVIOUS_SHA"
else
PREVIOUS_SHA=$CURRENT_SHA; exit_status=$?
INITIAL_COMMIT="true"
echo "::debug::Initial commit detected"
echo "::debug::Previous SHA: $PREVIOUS_SHA"
if [[ "$GITHUB_EVENT_FORCED" == "false" ]]; then
PREVIOUS_SHA=$GITHUB_EVENT_BEFORE
fi
if [[ -z "$PREVIOUS_SHA" || "$PREVIOUS_SHA" == "0000000000000000000000000000000000000000" ]]; then
PREVIOUS_SHA=$(git rev-parse "$(git branch -r --sort=-committerdate | head -1 | xargs)")
fi
if [[ "$PREVIOUS_SHA" == "$CURRENT_SHA" ]]; then
PREVIOUS_SHA=$(git rev-parse "$CURRENT_SHA^1")
if [[ "$PREVIOUS_SHA" == "$CURRENT_SHA" ]]; then
INITIAL_COMMIT="true"
echo "::debug::Initial commit detected"
fi
fi
else
PREVIOUS_SHA=$INPUT_BASE_SHA; exit_status=$?
PREVIOUS_SHA=$INPUT_BASE_SHA
TARGET_BRANCH=$(git name-rev --name-only "$PREVIOUS_SHA" 2>&1) && exit_status=$? || exit_status=$?
echo "::debug::Previous SHA: $PREVIOUS_SHA"
echo "::debug::Target branch: $TARGET_BRANCH"
CURRENT_BRANCH=$TARGET_BRANCH
fi
echo "::debug::Target branch $TARGET_BRANCH..."
echo "::debug::Current branch $CURRENT_BRANCH..."
echo "::debug::Verifying the previous commit SHA: $PREVIOUS_SHA"
git rev-parse --quiet --verify "$PREVIOUS_SHA^{commit}" 1>/dev/null 2>&1 && exit_status=$? || exit_status=$?
@@ -90,15 +99,18 @@ if [[ -z $GITHUB_BASE_REF ]]; then
exit 1
fi
else
echo "Running on a pull request event..."
TARGET_BRANCH=$GITHUB_BASE_REF
CURRENT_BRANCH=$GITHUB_HEAD_REF
echo "::debug::GITHUB_BASE_REF: $TARGET_BRANCH..."
if [[ -z $INPUT_BASE_SHA ]]; then
git fetch --no-tags -u --progress origin --depth=1 "${TARGET_BRANCH}":"${TARGET_BRANCH}" && exit_status=$? || exit_status=$?
PREVIOUS_SHA=$GITHUB_PULL_REQUEST_BASE_SHA && exit_status=$? || exit_status=$?
echo "::debug::Previous SHA: $PREVIOUS_SHA"
else
git fetch --no-tags -u --progress origin --depth=1 "$(git rev-parse --verify "$INPUT_BASE_SHA")" && exit_status=$? || exit_status=$?
PREVIOUS_SHA=$INPUT_BASE_SHA
TARGET_BRANCH=$(git name-rev --name-only "$PREVIOUS_SHA" 2>&1) && exit_status=$? || exit_status=$?
echo "::debug::Previous SHA: $PREVIOUS_SHA"

38
get-base-sha.sh Normal file
View File

@@ -0,0 +1,38 @@
#!/usr/bin/env bash
set -eu
if [[ -n $INPUT_PATH ]]; then
REPO_DIR="$GITHUB_WORKSPACE/$INPUT_PATH"
echo "Resolving repository path: $REPO_DIR"
if [[ ! -d "$REPO_DIR" ]]; then
echo "::error::Invalid repository path: $REPO_DIR"
exit 1
fi
cd "$REPO_DIR"
fi
if [[ -n "$INPUT_SINCE" ]]; then
BASE_SHA=$(git log --format="%H" --date=local --since="$INPUT_SINCE" --reverse | head -n 1)
if [[ -z "$BASE_SHA" ]]; then
echo "::warning::The BASE_SHA for date '$INPUT_SINCE' couldn't be determined."
fi
echo "::set-output name=base_sha::$BASE_SHA"
elif [[ -n "$INPUT_BASE_SHA" ]]; then
echo "::set-output name=base_sha::$INPUT_BASE_SHA"
elif [[ "$INPUT_SINCE_LAST_REMOTE_COMMIT" == "true" ]]; then
LAST_REMOTE_COMMIT=""
if [[ "$GITHUB_EVENT_FORCED" == "false" ]]; then
LAST_REMOTE_COMMIT=$GITHUB_EVENT_BEFORE
fi
if [[ -z "$LAST_REMOTE_COMMIT" || "$LAST_REMOTE_COMMIT" == "0000000000000000000000000000000000000000" ]]; then
LAST_REMOTE_COMMIT=$(git rev-parse "$(git branch -r --sort=-committerdate | head -1 | xargs)")
fi
if [[ "$INPUT_SHA" == "$LAST_REMOTE_COMMIT" ]]; then
LAST_REMOTE_COMMIT=$(git rev-parse "$INPUT_SHA^1")
fi
echo "::set-output name=base_sha::$LAST_REMOTE_COMMIT"
fi

View File

@@ -81,7 +81,7 @@ echo "Retrieving changes between $INPUT_PREVIOUS_SHA ($INPUT_TARGET_BRANCH) →
echo "Getting diff..."
if [[ -z "$INPUT_FILES_PATTERN_FILE" ]]; then
if [[ "$INPUT_HAS_CUSTOM_PATTERNS" == "false" ]]; then
if [[ "$INPUT_JSON" == "false" ]]; then
ADDED=$(get_diff "$INPUT_PREVIOUS_SHA" "$INPUT_CURRENT_SHA" A | awk -v d="$INPUT_SEPARATOR" '{s=(NR==1?s:s d)$0}END{print s}')
COPIED=$(get_diff "$INPUT_PREVIOUS_SHA" "$INPUT_CURRENT_SHA" C | awk -v d="$INPUT_SEPARATOR" '{s=(NR==1?s:s d)$0}END{print s}')

24
get-sha.sh Normal file
View File

@@ -0,0 +1,24 @@
#!/usr/bin/env bash
set -eu
if [[ -n $INPUT_PATH ]]; then
REPO_DIR="$GITHUB_WORKSPACE/$INPUT_PATH"
echo "Resolving repository path: $REPO_DIR"
if [[ ! -d "$REPO_DIR" ]]; then
echo "::error::Invalid repository path: $REPO_DIR"
exit 1
fi
cd "$REPO_DIR"
fi
if [[ -n "$INPUT_UNTIL" ]]; then
SHA=$(git log -1 --format="%H" --date=local --until="$INPUT_UNTIL")
if [[ -z "$SHA" ]]; then
echo "::warning::The SHA for date '$INPUT_UNTIL' couldn't be determined, falling back to the current sha."
fi
echo "::set-output name=sha::$SHA"
else
echo "::set-output name=sha::$INPUT_SHA"
fi